<template>
  <Line :data="preparedData" :options="options" />
</template>

<script>
import { Line } from 'vue-chartjs'
import {
  Chart as ChartJS,
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend
} from 'chart.js';

ChartJS.register(
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Legend
);

export default {
  name: "LineChartHistory",
  components: { Line },
  props: {
    // eslint-disable-next-line vue/require-default-prop
    chartData: {
      type: [Array, Object],
      required: true
    },
    chartLabels: {
      type: Array,
      required: true
    },
    title: {
      type: String,
      default: '[No title]',
      required: false
    },
    chartBackgroundColors: {
      type: Array,
      required: false,
      default () {
        return [
          'rgb(41, 114, 170)',
          'rgb(242, 242, 242)',
          'rgb(159, 242, 223)'
        ]
      }
    }
  },
  data () {
    return {
      preparedData: {
        labels: this.chartLabels,
        datasets: [
          {
            label: this.title,
            backgroundColor: this.chartBackgroundColors[0],
            data: this.chartData,
            fill: true,
            pointBackgroundColor: 'rgba(0,0,0,0.2)',
            tension: 0.2
          },
          {
            data: this.yes,
            backgroundColor: 'white'
          },
          {
            data: this.no,
            backgroundColor: 'black'
          }
        ]
      },
      options: {
        title: {
          display: false,
          text: this.title
        },
        scales: {
          yAxes: [{
            ticks: {
              beginAtZero: true,
              stepSize: parseInt(this.$env.SCORING_STEP_SIZE),
              max: 100
            },
            gridLines: {
              display: true
            }
          }],
          xAxes: [{
            gridLines: {
              display: true
            }
          }]
        },
        responsive: true,
        plugins: {
          legend: {
            display: false
          },
          tooltips: {
            // Toolbar an/aus
            enabled: true
          },
          datalabels: {
            display: false,
          }
        }
      }
    }
  }
};
</script>
